#include "c6x.h"

#define INT32 unsigned int
#define INT16 unsigned short
#define L1PCFG *(unsigned int *)0x01840020

INT32	dsrc_a, dsrc_b ;	/* input */
INT16	isft_a, isft_b ;	/* input */
INT32	result_a, result_b;	/* output */
INT32	cycle;

void main (void) {

	INT32 temp_a, check_a;
	INT32 temp_b, check_b;
	INT32 count1, count2;

//	cache invalidated by Invalidate_Cache of GEL

	L1PCFG = 0;	// 0: L1P cache disabled
//	L1PCFG = 4;	// 4: 32K cache

	TSCL = 0;
	count1 = TSCL;


	/***** 1st *****/

	/* Initialize */
	dsrc_a = 0x10000000 ;
	isft_a = 31 ;

	/* Initialize */
	dsrc_b = 0x10000000 ;
	isft_b = 4 ;

	/* Calcuration */
	temp_a  = dsrc_a << isft_a ;
	check_a = dsrc_a >> (31-isft_a) ;
	temp_a = (check_a > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_a;
	temp_a = (check_a < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_a;

	/* OUTPUT */
	result_a = temp_a;

	/* Calcuration */
	temp_b  = dsrc_b << isft_b ;
	check_b = dsrc_b >> (31-isft_b) ;
	temp_b = (check_b > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_b;
	temp_b = (check_b < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_b;

	/* OUTPUT */
	result_b = temp_b;


	/***** 2nd *****/

	/* Initialize */
	dsrc_a = 0x20000000 ;
	isft_a = 31 ;

	/* Initialize */
	dsrc_b = 0x20000000 ;
	isft_b = 4 ;

	/* Calcuration */
	temp_a  = dsrc_a << isft_a ;
	check_a = dsrc_a >> (31-isft_a) ;
	temp_a = (check_a > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_a;
	temp_a = (check_a < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_a;

	/* OUTPUT */
	result_a = temp_a;

	/* Calcuration */
	temp_b  = dsrc_b << isft_b ;
	check_b = dsrc_b >> (31-isft_b) ;
	temp_b = (check_b > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_b;
	temp_b = (check_b < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_b;

	/* OUTPUT */
	result_b = temp_b;


	/***** 3rd *****/

	/* Initialize */
	dsrc_a = 0x30000000 ;
	isft_a = 31 ;

	/* Initialize */
	dsrc_b = 0x30000000 ;
	isft_b = 4 ;

	/* Calcuration */
	temp_a  = dsrc_a << isft_a ;
	check_a = dsrc_a >> (31-isft_a) ;
	temp_a = (check_a > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_a;
	temp_a = (check_a < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_a;

	/* OUTPUT */
	result_a = temp_a;

	/* Calcuration */
	temp_b  = dsrc_b << isft_b ;
	check_b = dsrc_b >> (31-isft_b) ;
	temp_b = (check_b > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_b;
	temp_b = (check_b < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_b;

	/* OUTPUT */
	result_b = temp_b;


	/***** 4th *****/

	/* Initialize */
	dsrc_a = 0x40000000 ;
	isft_a = 31 ;

	/* Initialize */
	dsrc_b = 0x40000000 ;
	isft_b = 4 ;

	/* Calcuration */
	temp_a  = dsrc_a << isft_a ;
	check_a = dsrc_a >> (31-isft_a) ;
	temp_a = (check_a > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_a;
	temp_a = (check_a < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_a;

	/* OUTPUT */
	result_a = temp_a;

	/* Calcuration */
	temp_b  = dsrc_b << isft_b ;
	check_b = dsrc_b >> (31-isft_b) ;
	temp_b = (check_b > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_b;
	temp_b = (check_b < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_b;

	/* OUTPUT */
	result_b = temp_b;


	/***** 5th *****/

	/* Initialize */
	dsrc_a = 0x50000000 ;
	isft_a = 31 ;

	/* Initialize */
	dsrc_b = 0x50000000 ;
	isft_b = 4 ;

	/* Calcuration */
	temp_a  = dsrc_a << isft_a ;
	check_a = dsrc_a >> (31-isft_a) ;
	temp_a = (check_a > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_a;
	temp_a = (check_a < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_a;

	/* OUTPUT */
	result_a = temp_a;

	/* Calcuration */
	temp_b  = dsrc_b << isft_b ;
	check_b = dsrc_b >> (31-isft_b) ;
	temp_b = (check_b > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_b;
	temp_b = (check_b < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_b;

	/* OUTPUT */
	result_b = temp_b;


	/***** 6th *****/

	/* Initialize */
	dsrc_a = 0x60000000 ;
	isft_a = 31 ;

	/* Initialize */
	dsrc_b = 0x60000000 ;
	isft_b = 4 ;

	/* Calcuration */
	temp_a  = dsrc_a << isft_a ;
	check_a = dsrc_a >> (31-isft_a) ;
	temp_a = (check_a > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_a;
	temp_a = (check_a < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_a;

	/* OUTPUT */
	result_a = temp_a;

	/* Calcuration */
	temp_b  = dsrc_b << isft_b ;
	check_b = dsrc_b >> (31-isft_b) ;
	temp_b = (check_b > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_b;
	temp_b = (check_b < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_b;

	/* OUTPUT */
	result_b = temp_b;


	/***** 7th *****/

	/* Initialize */
	dsrc_a = 0x70000000 ;
	isft_a = 31 ;

	/* Initialize */
	dsrc_b = 0x70000000 ;
	isft_b = 4 ;

	/* Calcuration */
	temp_a  = dsrc_a << isft_a ;
	check_a = dsrc_a >> (31-isft_a) ;
	temp_a = (check_a > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_a;
	temp_a = (check_a < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_a;

	/* OUTPUT */
	result_a = temp_a;

	/* Calcuration */
	temp_b  = dsrc_b << isft_b ;
	check_b = dsrc_b >> (31-isft_b) ;
	temp_b = (check_b > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_b;
	temp_b = (check_b < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_b;

	/* OUTPUT */
	result_b = temp_b;


	/***** 8th *****/

	/* Initialize */
	dsrc_a = 0x80000000 ;
	isft_a = 31 ;

	/* Initialize */
	dsrc_b = 0x80000000 ;
	isft_b = 4 ;

	/* Calcuration */
	temp_a  = dsrc_a << isft_a ;
	check_a = dsrc_a >> (31-isft_a) ;
	temp_a = (check_a > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_a;
	temp_a = (check_a < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_a;

	/* OUTPUT */
	result_a = temp_a;

	/* Calcuration */
	temp_b  = dsrc_b << isft_b ;
	check_b = dsrc_b >> (31-isft_b) ;
	temp_b = (check_b > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_b;
	temp_b = (check_b < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_b;

	/* OUTPUT */
	result_b = temp_b;


	/***** 9th *****/

	/* Initialize */
	dsrc_a = 0x90000000 ;
	isft_a = 31 ;

	/* Initialize */
	dsrc_b = 0x90000000 ;
	isft_b = 4 ;

	/* Calcuration */
	temp_a  = dsrc_a << isft_a ;
	check_a = dsrc_a >> (31-isft_a) ;
	temp_a = (check_a > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_a;
	temp_a = (check_a < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_a;

	/* OUTPUT */
	result_a = temp_a;

	/* Calcuration */
	temp_b  = dsrc_b << isft_b ;
	check_b = dsrc_b >> (31-isft_b) ;
	temp_b = (check_b > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_b;
	temp_b = (check_b < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_b;

	/* OUTPUT */
	result_b = temp_b;


	/***** 10th *****/

	/* Initialize */
	dsrc_a = 0xa0000000 ;
	isft_a = 31 ;

	/* Initialize */
	dsrc_b = 0xa0000000 ;
	isft_b = 4 ;

	/* Calcuration */
	temp_a  = dsrc_a << isft_a ;
	check_a = dsrc_a >> (31-isft_a) ;
	temp_a = (check_a > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_a;
	temp_a = (check_a < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_a;

	/* OUTPUT */
	result_a = temp_a;

	/* Calcuration */
	temp_b  = dsrc_b << isft_b ;
	check_b = dsrc_b >> (31-isft_b) ;
	temp_b = (check_b > (INT32)0x0000000000000000L) ? (INT32)0x000000007FFFFFFFL : temp_b;
	temp_b = (check_b < (INT32)0xFFFFFFFFFFFFFFFFL) ? (INT32)0xFFFFFFFF80000000L : temp_b;

	/* OUTPUT */
	result_b = temp_b;



	count2 = TSCL;
	cycle = count2 - count1;

	while (1);
}
